﻿Shader "CrispyPin/CA Output"
{
	Properties
	{
		[NoScaleOffset]
		_MainTex ("RenderTexture", 2D) = "white" {}
		_Emission ("Emission", Range(0, 1)) = 0.5
	}
	SubShader
	{
		Tags { "RenderType"="Opaque" }
		LOD 200

		CGPROGRAM
		// Physically based Standard lighting model, and enable shadows on all light types
		#pragma surface surf Standard fullforwardshadows

		// Use shader model 3.0 target, to get nicer looking lighting
		#pragma target 3.0

		struct Input {
			float2 uv_MainTex;
		};

		sampler2D _MainTex;
		float _Emission;

		void surf (Input IN, inout SurfaceOutputStandard o) {
			// don't interfere with simulation camera
			if(_ProjectionParams.z < 1) discard;

			// Albedo comes from a texture tinted by color
			float4 c = tex2D(_MainTex, IN.uv_MainTex);
			o.Albedo = c.rgb;
			o.Emission = c.rgb * _Emission;

		}
		ENDCG
	}
	FallBack "Diffuse"
}
